<?php

namespace App\Http\Requests;

use Illuminate\Validation\Rule;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\Request;
use Illuminate\Foundation\Http\FormRequest;
use Illuminate\Validation\ValidationException;
use Illuminate\Contracts\Validation\Validator;
use Illuminate\Http\Exceptions\HttpResponseException;

class UserRequest extends FormRequest
{
    /**
     * Determine if the user is authorized to make this request.
     *
     * @return bool
     */
    public function authorize()
    {
        if (! Auth::check()) {
            return false;
        }
        if(Auth::user()->role != 'admin' )
        {
            return false;
        }
        return Auth::check();
    }

    /**
     * Get the validation rules that apply to the request.
     *
     * @return array
     */
    public function rules()
    {
        $rules=[
            'photo' => 'sometimes',
            'name'=> 'required|min:3',
            'email' => [
                'required',
                'email',
                Rule::unique('users')->ignore($this->user? $this->user->id : 0, 'id')
            ],
            'phone'=> [
                "required",
                "numeric",
                Rule::unique('users')->ignore($this->user? $this->user->id : 0, 'id')
            ],
        ];

        if ( !$this->user  ) {
            $rules['password'] ='required|confirmed';
        } else {
            $rules['password'] ='sometimes|confirmed';
        }

        if ( !$this->user || !$this->user->role || $this->user->role !== 'admin' ) {
            $rules['modules'] = 'sometimes|array|exists:modules,id';
        }
        if ($this->user->role == 'user'){
            // $rules['register_steps'] = 'required|array';
            $rules['score'] = 'sometimes|nullable|numeric';
        }

        return $rules;
    }

    /**
     * Get custom attributes for validator errors.
     *
     * @return array
     */
    public function attributes()
    {
        $attributes= [
            'name'=> __('users.name'),
            'phone'=> __('users.phone'),
            'email'=> __('users.email'),
            'photo'=> __('users.photo'),
            'password'=> __('users.password'),
            'password_confirmation'=> __('users.password_confirmation'),
            'modules'=> __('users.modules'),
        ];
        return $attributes;
    }

    /**
     * Handle a failed validation attempt.
     *
     * Override the parent method action if the request is for AJAX
     *
     * @param Validator $validator
     * @return void
     *
     * @throws ValidationException
     */
    protected function failedValidation(Validator $validator)
    {
        // Change response attitude if the request done via Ajax requests like API requests

        if(Request::wantsJson()){
            $errors = (new ValidationException($validator))->errors();
            throw new HttpResponseException(response()->json(['errors' => $errors], 422));
        } else {
            // Do the original action of the Form request class
            // throw new HttpResponseException(response($validator->errors()->first(), 302));
            parent::failedValidation($validator);
        }
    }
}
